VERSION 5.00
Begin VB.UserControl WoodButton 
   ClientHeight    =   8490
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9645
   ScaleHeight     =   8490
   ScaleWidth      =   9645
   ToolboxBitmap   =   "MyButton.ctx":0000
   Begin VB.Image imgDisabled 
      Height          =   1050
      Left            =   2400
      Picture         =   "MyButton.ctx":0312
      Top             =   5100
      Width           =   1485
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Label1"
      Height          =   195
      Left            =   375
      TabIndex        =   1
      Top             =   165
      Width           =   480
   End
   Begin VB.Shape Shape1 
      BorderColor     =   &H00000000&
      FillColor       =   &H0000FFFF&
      Height          =   1725
      Left            =   105
      Shape           =   4  'Rounded Rectangle
      Top             =   75
      Width           =   2000
   End
   Begin VB.Label lblShortcut 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "label1"
      Height          =   195
      Left            =   3015
      TabIndex        =   0
      Top             =   1785
      Width           =   420
   End
   Begin VB.Image imgButton 
      Height          =   2010
      Left            =   45
      Stretch         =   -1  'True
      Top             =   15
      Width           =   3480
   End
   Begin VB.Image imgUp 
      Height          =   1050
      Left            =   3990
      Picture         =   "MyButton.ctx":1984
      Top             =   5145
      Visible         =   0   'False
      Width           =   1485
   End
   Begin VB.Image imgDown 
      Height          =   1050
      Left            =   5625
      Picture         =   "MyButton.ctx":3A66
      Stretch         =   -1  'True
      Top             =   5130
      Visible         =   0   'False
      Width           =   1500
   End
End
Attribute VB_Name = "WoodButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum HorAlignType
   HorAlign_Left
   HorAlign_Center
   HorAlign_Right
   HorAlign_Custom
End Enum

Public Enum VerAlignType
   VerAlign_Top
   VerAlign_Center
   verAlign_Bottom
   VerAlign_Custom
End Enum

Private m_intFrameMargin As Integer
Private m_enumHorAlign As HorAlignType
Private m_enumVerAlign As VerAlignType
Private m_objCaptionFont As StdFont
Private m_objShortcutFont As StdFont
Private m_intLabelLeft As Integer
Private m_intLabelTop As Integer
Private m_intShortcutRight As Integer
Private m_intShortcutBottom As Integer

Public Event Click()

Public Property Get Enabled() As Boolean

   Enabled = Not (imgButton.Picture = imgDisabled.Picture)
   
End Property

Public Property Let Enabled(ByVal boolNewValue As Boolean)

   imgButton.Picture = IIf(boolNewValue, imgUp.Picture, imgDisabled.Picture)

End Property



Public Property Get ShortcutCaption() As String
   
   ShortcutCaption = lblShortcut.Caption

End Property

Public Property Let ShortcutCaption(ByVal strNewValue As String)

   lblShortcut.Caption = strNewValue
   lblShortcut.Move ScaleWidth - (lblShortcut.Width + ShortcutRight), _
   ScaleHeight - (lblShortcut.Height + ShortcutBottom)

   PropertyChanged "ShortcutCaption"
   
End Property

Public Property Let HorizontalAlign(ByVal intNewValue As HorAlignType)

   Select Case intNewValue
      Case HorAlign_Left
         lblCaption.Left = 0
         m_enumHorAlign = intNewValue
      Case HorAlign_Center
         lblCaption.Left = (ScaleWidth / 2) - (lblCaption.Width / 2)
         m_enumHorAlign = intNewValue
      Case HorAlign_Right
         lblCaption.Left = ScaleWidth - lblCaption.Width
         m_enumHorAlign = intNewValue
      Case HorAlign_Custom
         m_enumHorAlign = intNewValue
   End Select
   
   PropertyChanged "HorizontalAlign"

End Property

Public Property Get HorizontalAlign() As HorAlignType

   HorizontalAlign = m_enumHorAlign
   
End Property

Public Property Let VerticalAlign(ByVal intNewValue As VerAlignType)

   Select Case intNewValue
      Case VerAlign_Top
         lblCaption.Top = 0
         m_enumVerAlign = intNewValue
      Case VerAlign_Center
         lblCaption.Top = (ScaleHeight / 2) - (lblCaption.Height / 2)
         m_enumVerAlign = intNewValue
      Case verAlign_Bottom
         lblCaption.Top = ScaleHeight - lblCaption.Height
         m_enumVerAlign = intNewValue
      Case VerAlign_Custom
         m_enumVerAlign = intNewValue
   End Select
   
   PropertyChanged "VerticalAlign"

End Property

Public Property Get VerticalAlign() As VerAlignType
   
   VerticalAlign = m_enumVerAlign
   
End Property




Public Property Let LabelLeft(ByVal intNewValue As Integer)

   lblCaption.Left = intNewValue
   m_intLabelLeft = intNewValue
   HorizontalAlign = HorAlign_Custom
   
   PropertyChanged "LabelLeft"

End Property

Public Property Get LabelLeft() As Integer

   LabelLeft = m_intLabelLeft

End Property

Public Property Let LabelTop(ByVal intNewValue As Integer)

   lblCaption.Top = intNewValue
   m_intLabelTop = intNewValue
   VerticalAlign = VerAlign_Custom
   
   
   PropertyChanged "LabelTop"

End Property

Public Property Get LabelTop() As Integer

   LabelTop = m_intLabelTop

End Property

Public Property Set ShortcutFont(ByRef objFont As StdFont)

   Set m_objShortcutFont = objFont
   Set lblShortcut.Font = m_objShortcutFont
   PropertyChanged "ShortcutFont"

End Property

Public Property Get ShortcutFont() As StdFont

   Set ShortcutFont = m_objShortcutFont

End Property

Public Property Set CaptionFont(ByRef objFont As StdFont)

   Set m_objCaptionFont = objFont
   Set lblCaption.Font = m_objCaptionFont
   PropertyChanged "CaptionFont"

End Property

Public Property Get CaptionFont() As StdFont

   Set CaptionFont = m_objCaptionFont

End Property


Public Property Let Caption(ByVal strNewValue As String)

   lblCaption.Caption = strNewValue
   PropertyChanged "Caption"

End Property

Public Property Get Caption() As String

   Caption = lblCaption.Caption

End Property


Public Property Get LabelColor() As OLE_COLOR

   LabelColor = lblCaption.ForeColor

End Property

Public Property Let LabelColor(ByVal lngNewValue As OLE_COLOR)

   lblCaption.ForeColor = lngNewValue
   PropertyChanged "LabelColor"
   
End Property

Public Property Get ShortcutColor() As OLE_COLOR

   ShortcutColor = lblShortcut.ForeColor

End Property

Public Property Let ShortcutColor(ByVal lngNewValue As OLE_COLOR)

   lblShortcut.ForeColor = lngNewValue
   PropertyChanged "ShortcutColor"
   
End Property

Public Property Get ShowShortcut() As Boolean

   ShowShortcut = lblShortcut.Visible = True

End Property

Public Property Let ShowShortcut(ByVal boolNewValue As Boolean)

   lblShortcut.Visible = boolNewValue
   PropertyChanged "ShowShortcut"

End Property

Public Property Get ShowFrame() As Boolean
   
   ShowFrame = Shape1.Visible

End Property

Public Property Let ShowFrame(ByVal boolNewValue As Boolean)

   Shape1.Visible = boolNewValue
   PropertyChanged "ShowFrame"
   
End Property

Public Property Let ShortcutRight(ByVal intNewValue As Integer)

   m_intShortcutRight = ScaleWidth - (lblShortcut.Width + intNewValue)
   lblShortcut.Left = ScaleWidth - (lblShortcut.Width + intNewValue)

End Property

Public Property Get ShortcutRight() As Integer

   ShortcutRight = m_intShortcutRight

End Property

Public Property Let ShortcutBottom(ByVal intNewValue As Integer)

   m_intShortcutBottom = ScaleHeight - (lblShortcut.Height + intNewValue)
   lblShortcut.Top = ScaleHeight - (lblShortcut.Height + intNewValue)

End Property

Public Property Get ShortcutBottom() As Integer

   ShortcutBottom = m_intShortcutBottom

End Property



Private Sub imgButton_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

   If Not Enabled Then Exit Sub
   imgButton.Picture = imgDown.Picture

End Sub

Private Sub imgButton_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

   If Not Enabled Then Exit Sub
   
   imgButton.Picture = imgUp.Picture
   RaiseEvent Click

End Sub

Private Sub lblCaption_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

   imgButton_MouseDown Button, Shift, X, Y

End Sub

Private Sub lblCaption_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

   imgButton_MouseUp Button, Shift, X, Y

End Sub

Private Sub lblShortcut_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

   imgButton_MouseDown Button, Shift, X, Y

End Sub

Private Sub lblShortcut_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

   imgButton_MouseUp Button, Shift, X, Y

End Sub





Private Sub UserControl_InitProperties()

   HorizontalAlign = HorAlign_Custom
   LabelLeft = 120
   LabelTop = 60
   VerticalAlign = VerAlign_Top
   ShowFrame = False
   Caption = UserControl.Extender.Name
   ShortcutCaption = "shortcut"
   ShowShortcut = True
   ShortcutKey = vbKeyF2
   ShortcutColor = vbBlue
   Set m_objCaptionFont = lblCaption.Font
   Set m_objShortcutFont = lblShortcut.Font
   
   

End Sub


Private Sub UserControl_Paint()
   
   On Error Resume Next
   
   
   imgButton.Picture = imgUp.Picture
   imgButton.Move 0, 0, ScaleWidth, ScaleHeight
   
   Dim FrameMargin As Single
   
   FrameMargin = (ScaleWidth * 0.9) / 2
   
   Shape1.Move FrameMargin, FrameMargin, ScaleWidth - 2 * FrameMargin, ScaleHeight - 2 * FrameMargin
   Shape1.Visible = ShowFrame
   
   lblShortcut.Move ScaleWidth - (lblShortcut.Width + ShortcutRight), _
   ScaleHeight - (lblShortcut.Height + ShortcutBottom)

   lblShortcut.Visible = ShowShortcut

   HorizontalAlign = m_enumHorAlign
   VerticalAlign = m_enumVerAlign
   
   UserControl.Refresh
   

End Sub

Private Sub UserControl_Resize()
 
   UserControl_Paint

End Sub

Private Sub UserControl_Show()

   UserControl_Paint

End Sub

Private Sub UserControl_WriteProperties(PropBag As _
      PropertyBag)
   
   With PropBag
      .WriteProperty "Caption", Caption, Extender.Name
      .WriteProperty "ShortcutCaption", ShortcutCaption, "F1"
      .WriteProperty "HorizontalAlign", HorizontalAlign, HorAlign_Center
      .WriteProperty "VerticalAlign", VerticalAlign, VerAlign_Top
      .WriteProperty "LabelLeft", LabelLeft, m_intLabelLeft
      .WriteProperty "LabelTop", LabelTop, m_intLabelTop
      .WriteProperty "ShortcutFont", ShortcutFont
      .WriteProperty "CaptionFont", CaptionFont
      .WriteProperty "LabelColor", LabelColor
      .WriteProperty "ShortcutColor", ShortcutColor
      .WriteProperty "ShowShortcut", ShowShortcut
      .WriteProperty "ShowFrame", ShowFrame
      .WriteProperty "ShortcutRight", m_intShortcutRight
      .WriteProperty "ShortcutButtom", m_intShortcutBottom
      .WriteProperty "Enabled", True
   End With
      
End Sub


Private Sub UserControl_ReadProperties(PropBag As _
      PropertyBag)
   
   With PropBag
      Caption = .ReadProperty("Caption", Extender.Name)
      ShortcutCaption = .ReadProperty("ShortcutCaption", "F1")
      HorizontalAlign = .ReadProperty("HorizontalAlign", HorAlign_Center)
      VerticalAlign = .ReadProperty("VerticalAlign", VerAlign_Center)
      LabelLeft = .ReadProperty("LabelLeft", m_intLabelLeft)
      LabelTop = .ReadProperty("LabelTop", m_intLabelTop)
      Set ShortcutFont = .ReadProperty("ShortcutFont")
      Set CaptionFont = .ReadProperty("CaptionFont")
      LabelColor = .ReadProperty("LabelColor", lblCaption.ForeColor)
      ShortcutColor = .ReadProperty("ShortcutColor", lblShortcut.ForeColor)
      ShowShortcut = .ReadProperty("ShowShortcut", lblShortcut.Visible)
      ShowFrame = .ReadProperty("ShowFrame", Shape1.Visible)
      ShortcutRight = .ReadProperty("ShortcutRight", m_intShortcutRight)
      ShortcutBottom = .ReadProperty("ShortcutBottom", m_intShortcutBottom)
      Enabled = .ReadProperty("Enabled", True)

   End With


End Sub




Public Sub ClickIt()

   Dim lngWait As Single
   imgButton_MouseDown 1, 0, 0, 0
   lngWait = Timer
   Do Until Timer > lngWait + 0.1
      DoEvents
   Loop
   imgButton_MouseUp 1, 0, 0, 0

End Sub


